#ifndef _DATA_ACCESS
#define _DATA_ACCESS

#define Read_Mem8(adr) \
PCMemory[adr] \

#define Write_Mem8(adr,val) \
PCMemory[adr]=val \

#define Read_Mem16(adr) \
PCMemory[adr]+(PCMemory[adr+1]<<8) \

#define Write_Mem16(adr,val) \
PCMemory[adr]=val&0xFF; \
PCMemory[adr+1]=val>>8 \

#define Read_Mem32(adr) \
PCMemory[adr]+(PCMemory[adr+1]<<8)+(PCMemory[adr+2]<<16)+(PCMemory[adr+3]<<24) \

#define Write_Mem32(adr,val) \
PCMemory[adr]=val&0xFF; \
PCMemory[adr+1]=(val>>8)&0xFF; \
PCMemory[adr+2]=(val>>16)&0xFF; \
PCMemory[adr+3]=val>>24 \

#define Read_Reg8(index) \
(index<4)?Registers[index].Word.Byte.L:Registers[index-4].Word.Byte.H \

#define Write_Reg8(index,val) \
(index<4)?(Registers[index].Word.Byte.L=val):(Registers[index-4].Word.Byte.H=val) \

#define Write_Reg16(index,val) Registers[index].Word.X=val

#define Write_Seg(index,val) SegRegisters[index]=val

#define Read_Reg16(index) Registers[index].Word.X

#define Read_Seg(index) SegRegisters[index]

/*
{"[BX+SI]","[BX+DI]","[BP+SI]","[BP+DI]","[SI]","[DI]","[imm16]","[BX]"};
*/

#define Read_Mod0(val) \
switch(Rm) { \
case 0x00 : val=PCMemory[(DS<<4)+BX+SI]; break; \
case 0x01 : val=PCMemory[(DS<<4)+BX+DI]; break; \
case 0x02 : val=PCMemory[(DS<<4)+BP+SI]; break; \
case 0x03 : val=PCMemory[(DS<<4)+BP+DI]; break; \
case 0x04 : val=PCMemory[(DS<<4)+SI]; break; \
case 0x05 : val=PCMemory[(DS<<4)+DI]; break; \
case 0x06 : val=Read_Mem16((CS<<4)+IP); IP+=2; break; \
case 0x07 : val=PCMemory[(DS<<4)+BX]; break; \
} \

/*
{"[BX+SI+imm8]","[BX+DI+imm8]","[BP+SI+imm8]","[BP+DI+imm8]","[SI+imm8]","[DI+imm8]","[BP+imm8]","[BX+imm8]"};
*/

#define Read_Mod1(val) \
switch(Rm) { \
case 0x00 : val=PCMemory[(DS<<4)+BX+SI+Read_Mem8((CS<<4)+IP)]; IP+=1; break; \
case 0x01 : val=PCMemory[(DS<<4)+BX+DI+Read_Mem8((CS<<4)+IP)]; IP+=1; break; \
case 0x02 : val=PCMemory[(DS<<4)+BP+SI+Read_Mem8((CS<<4)+IP)]; IP+=1; break; \
case 0x03 : val=PCMemory[(DS<<4)+BP+DI+Read_Mem8((CS<<4)+IP)]; IP+=1; break; \
case 0x04 : val=PCMemory[(DS<<4)+SI+Read_Mem8((CS<<4)+IP)]; IP+=1; break; \
case 0x05 : val=PCMemory[(DS<<4)+DI+Read_Mem8((CS<<4)+IP)]; IP+=1; break; \
case 0x06 : val=PCMemory[(DS<<4)+BP+Read_Mem8((CS<<4)+IP)]; IP+=1; break; \
case 0x07 : val=PCMemory[(DS<<4)+BX+Read_Mem8((CS<<4)+IP)]; IP+=1; break; \
} \

/*
{"[BX+SI+imm16]","[BX+DI+imm16]","[BX+SI+imm16]","[BX+DI+imm16]","[SI+imm16]","[DI+imm16]","[BP+imm16]","[BX+imm16]"};
*/

#define Read_Mod2(val) \
switch(Rm) { \
case 0x00 : val=PCMemory[(DS<<4)+BX+SI+Read_Mem16((CS<<4)+IP)]; IP+=2; break; \
case 0x01 : val=PCMemory[(DS<<4)+BX+DI+Read_Mem16((CS<<4)+IP)]; IP+=2; break; \
case 0x02 : val=PCMemory[(DS<<4)+BX+SI+Read_Mem16((CS<<4)+IP)]; IP+=2; break; \
case 0x03 : val=PCMemory[(DS<<4)+BX+DI+Read_Mem16((CS<<4)+IP)]; IP+=2; break; \
case 0x04 : val=PCMemory[(DS<<4)+SI+Read_Mem16((CS<<4)+IP)]; IP+=2; break; \
case 0x05 : val=PCMemory[(DS<<4)+DI+Read_Mem16((CS<<4)+IP)]; IP+=2; break; \
case 0x06 : val=PCMemory[(DS<<4)+BP+Read_Mem16((CS<<4)+IP)]; IP+=2; break; \
case 0x07 : val=PCMemory[(DS<<4)+BX+Read_Mem16((CS<<4)+IP)]; IP+=2; break; \
} \

/*
{"[BX+SI]","[BX+DI]","[BP+SI]","[BP+DI]","[SI]","[DI]","[imm16]","[BX]"};
*/

#define Write_Mod0(val) \
switch(Rm) { \
case 0x00 : PCMemory[(DS<<4)+BX+SI]=val; break; \
case 0x01 : PCMemory[(DS<<4)+BX+DI]=val; break; \
case 0x02 : PCMemory[(DS<<4)+BP+SI]=val; break; \
case 0x03 : PCMemory[(DS<<4)+BP+DI]=val; break; \
case 0x04 : PCMemory[(DS<<4)+SI]=val; break; \
case 0x05 : PCMemory[(DS<<4)+DI]=val; break; \
case 0x06 : PCMemory[Read_Mem16((CS<<4)+IP)]=val; IP+=2; break; \
case 0x07 : PCMemory[(DS<<4)+BX]=val; break; \
} \

/*
{"[BX+SI+imm8]","[BX+DI+imm8]","[BP+SI+imm8]","[BP+DI+imm8]","[SI+imm8]","[DI+imm8]","[BP+imm8]","[BX+imm8]"};
*/

#define Write_Mod1(val) \
switch(Rm) { \
case 0x00 : PCMemory[(DS<<4)+BX+SI+Read_Mem8((CS<<4)+IP)]=val; IP+=1; break; \
case 0x01 : PCMemory[(DS<<4)+BX+DI+Read_Mem8((CS<<4)+IP)]=val; IP+=1; break; \
case 0x02 : PCMemory[(DS<<4)+BP+SI+Read_Mem8((CS<<4)+IP)]=val; IP+=1; break; \
case 0x03 : PCMemory[(DS<<4)+BP+DI+Read_Mem8((CS<<4)+IP)]=val; IP+=1; break; \
case 0x04 : PCMemory[(DS<<4)+SI+Read_Mem8((CS<<4)+IP)]=val; IP+=1; break; \
case 0x05 : PCMemory[(DS<<4)+DI+Read_Mem8((CS<<4)+IP)]=val; IP+=1; break; \
case 0x06 : PCMemory[(DS<<4)+BP+Read_Mem8((CS<<4)+IP)]=val; IP+=1; break; \
case 0x07 : PCMemory[(DS<<4)+BX+Read_Mem8((CS<<4)+IP)]=val; IP+=1; break; \
} \

/*
{"[BX+SI+imm16]","[BX+DI+imm16]","[BX+SI+imm16]","[BX+DI+imm16]","[SI+imm16]","[DI+imm16]","[BP+imm16]","[BX+imm16]"};
*/

#define Write_Mod2(val) \
switch(Rm) { \
case 0x00 : PCMemory[(DS<<4)+BX+SI+Read_Mem16((CS<<4)+IP)]=val; IP+=2; break; \
case 0x01 : PCMemory[(DS<<4)+BX+DI+Read_Mem16((CS<<4)+IP)]=val; IP+=2; break; \
case 0x02 : PCMemory[(DS<<4)+BX+SI+Read_Mem16((CS<<4)+IP)]=val; IP+=2; break; \
case 0x03 : PCMemory[(DS<<4)+BX+DI+Read_Mem16((CS<<4)+IP)]=val; IP+=2; break; \
case 0x04 : PCMemory[(DS<<4)+SI+Read_Mem16((CS<<4)+IP)]=val; IP+=2; break; \
case 0x05 : PCMemory[(DS<<4)+DI+Read_Mem16((CS<<4)+IP)]=val; IP+=2; break; \
case 0x06 : PCMemory[(DS<<4)+BP+Read_Mem16((CS<<4)+IP)]=val; IP+=2; break; \
case 0x07 : PCMemory[(DS<<4)+BX+Read_Mem16((CS<<4)+IP)]=val; IP+=2; break; \
} \

#define Read_rm8(val) \
switch(Mod) { \
case 0x00 : Read_Mod0(val); break; \
case 0x01 : Read_Mod1(val); break; \
case 0x02 : Read_Mod2(val); break; \
case 0x03 : val=Read_Reg8(Rm); break; \
} \

#define Read_rm16(val) \
switch(Mod) { \
case 0x00 : Read_Mod0(val); break; \
case 0x01 : Read_Mod1(val); break; \
case 0x02 : Read_Mod2(val); break; \
case 0x03 : val=Read_Reg16(Rm); break; \
} \

#define Write_rm8(val) \
switch(Mod) { \
case 0x00 : Write_Mod0(val); break; \
case 0x01 : Write_Mod1(val); break; \
case 0x02 : Write_Mod2(val); break; \
case 0x03 : Write_Reg8(Rm,val); break; \
} \

#define Write_rm16(val) \
switch(Mod) { \
case 0x00 : Write_Mod0(val); break; \
case 0x01 : Write_Mod1(val); break; \
case 0x02 : Write_Mod2(val); break; \
case 0x03 : Write_Reg16(Rm,val); break; \
} \

#endif
