#ifndef _BRANCH_8
#define _BRANCH_8

#define JMP_rel8 \
IP+=(signed char)CPUReadMemory8() \

//70  cb         JO rel8           7+m,3    Jump short if overflow (OF=1)
#define JO_rel8 \
aux8=CPUReadMemory8(); \
if (GetOF()) \
	IP+=(signed char)aux8 \

//71  cb         JNO rel8          7+m,3    Jump short if not overflow (OF=0)
#define JNO_rel8 \
aux8=CPUReadMemory8(); \
if (!GetOF()) \
	IP+=(signed char)aux8 \

//72  cb         JB rel8           7+m,3    Jump short if below (CF=1)
#define JB_rel8 \
aux8=CPUReadMemory8(); \
if (GetCF()) \
	IP+=(signed char)aux8 \
//72  cb         JC rel8           7+m,3    Jump short if carry (CF=1)
#define JC_rel8 JB_rel8
//72  cb         JNAE rel8         7+m,3    Jump short if not above or equal (CF=1)
#define JNAE_rel8 JB_rel8

//73  cb         JNB rel8          7+m,3    Jump short if not below (CF=0)
#define JNB_rel8 \
aux8=CPUReadMemory8(); \
if (!GetCF()) \
	IP+=(signed char)aux8 \
//73  cb         JNC rel8          7+m,3    Jump short if not carry (CF=0)
#define JNC_rel8 JNB_rel8
//73  cb         JAE rel8          7+m,3    Jump short if above or equal (CF=0)
#define JAE_rel8 JNB_rel8

//74  cb         JE rel8           7+m,3    Jump short if equal (ZF=1)
#define JE_rel8 \
aux8=CPUReadMemory8(); \
if (GetZF()) \
	IP+=(signed char)aux8 \
//74  cb         JZ rel8           7+m,3    Jump short if zero (ZF = 1)
#define JZ_rel8 JE_rel8

//75  cb         JNE rel8          7+m,3    Jump short if not equal (ZF=0)
#define JNE_rel8 \
aux8=CPUReadMemory8(); \
if (!GetZF()) \
	IP+=(signed char)aux8 \
//75  cb         JNZ rel8          7+m,3    Jump short if not zero (ZF=0)
#define JNZ_rel8 JNE_rel8

//76  cb         JBE rel8          7+m,3    Jump short if below or equal (CF=1 or ZF=1)
#define JBE_rel8 \
aux8=CPUReadMemory8(); \
if (GetCF()||GetZF()) \
	IP+=(signed char)aux8 \
//76  cb         JNA rel8          7+m,3    Jump short if not above (CF=1 or ZF=1)
#define JNA_rel8 JBE_rel8

//77  cb         JA rel8           7+m,3    Jump short if above (CF=0 and ZF=0)
#define JA_rel8 \
aux8=CPUReadMemory8(); \
if (!GetCF() && !GetZF()) \
	IP+=(signed char)aux8 \
//77  cb         JNBE rel8         7+m,3    Jump short if not below or equal (CF=0 and ZF=0)
#define JNBE_rel8 JA_rel8

//78  cb         JS rel8           7+m,3    Jump short if sign (SF=1)
#define JS_rel8 \
aux8=CPUReadMemory8(); \
if (GetSF()) \
	IP+=(signed char)aux8 \

//79  cb         JNS rel8          7+m,3    Jump short if not sign (SF=0)
#define JNS_rel8 \
aux8=CPUReadMemory8(); \
if (!GetSF()) \
	IP+=(signed char)aux8 \

//7A  cb         JP rel8           7+m,3    Jump short if parity (PF=1)
#define JP_rel8 \
aux8=CPUReadMemory8(); \
if (GetPF()) \
	IP+=(signed char)aux8 \
//7A  cb         JPE rel8          7+m,3    Jump short if parity even (PF=1)
#define JPE_rel8 JP_rel8

//7B  cb         JNP rel8          7+m,3    Jump short if not parity (PF=0)
#define JNP_rel8 \
aux8=CPUReadMemory8(); \
if (!GetPF()) \
	IP+=(signed char)aux8 \
//7B  cb         JPO rel8          7+m,3    Jump short if parity odd (PF=0)
#define JPO_rel8 JNP_rel8

//7C  cb         JL rel8           7+m,3    Jump short if less (SF<>OF)
#define JL_rel8 \
aux8=CPUReadMemory8(); \
if (GetSF() != GetOF()) \
	IP+=(signed char)aux8 \
//7C  cb         JNGE rel8         7+m,3    Jump short if not greater or equal (SF<>OF)
#define JNGE_rel8 JL_rel8

//7D  cb         JNL rel8          7+m,3    Jump short if not less (SF=OF)
#define JNL_rel8 \
aux8=CPUReadMemory8(); \
if (GetSF() == GetOF()) \
	IP+=(signed char)aux8 \
//7D  cb         JGE rel8          7+m,3    Jump short if greater or equal (SF=OF)
#define JGE_rel8 JNL_rel8

//7E  cb         JLE rel8          7+m,3    Jump short if less or equal (ZF=1 and SF<>OF)
#define JLE_rel8 \
aux8=CPUReadMemory8(); \
if (GetZF() && (GetSF() != GetOF())) \
	IP+=(signed char)aux8 \
//7E  cb         JNG rel8          7+m,3    Jump short if not greater (ZF=1 or SF<>OF)
#define JNG_rel8 JLE_rel8

//7F  cb         JG rel8           7+m,3    Jump short if greater (ZF=0 and SF=OF)
#define JG_rel8 \
aux8=CPUReadMemory8(); \
if (!GetZF() && (GetSF() == GetOF())) \
	IP+=(signed char)aux8 \
//7F  cb         JNLE rel8         7+m,3    Jump short if not less or equal (ZF=0 and SF=OF)
#define JNLE_rel8 JG_rel8

#endif
