#ifndef _DISASM
#define _DISASM

static char *DisasmOpcodes[256] =
{
  "ADD rm8,r8"  ,"ADD rm16,r16"  ,"ADD r8,rm8"  ,"ADD r16,rm16","ADD AL,imm8" ,"ADD AX,imm16","PUSH ES"  ,"POP ES"   ,
  "OR  rm8,r8"  ,"OR  rm16,r16"  ,"OR  r8,rm8"  ,"OR  r16,rm16","OR  AL,imm8" ,"OR  AX,imm16","PUSH CS"  ,"DB 0F"    ,
  "ADC rm8,r8"  ,"ADC rm16,r16"  ,"ADC r8,rm8"  ,"ADC r16,rm16","ADC AL,imm8" ,"ADC AX,imm16","PUSH SS"  ,"POP SS"   ,
  "SBB rm8,r8"  ,"SBB rm16,r16"  ,"SBB r8,rm8"  ,"SBB r16,rm16","SBB AL,imm8" ,"SBB AX,imm16","PUSH DS"  ,"POP DS"   ,
  "AND rm8,r8"  ,"AND rm16,r16"  ,"AND r8,rm8"  ,"AND r16,rm16","AND AL,imm8" ,"AND AX,imm16","SEG=ES"   ,"DAA"      ,
  "SUB rm8,r8"  ,"SUB rm16,r16"  ,"SUB r8,rm8"  ,"SUB r16,rm16","SUB AL,imm8" ,"SUB AX,imm16","SEG=CS"   ,"DAS"      ,
  "XOR rm8,r8"  ,"XOR rm16,r16"  ,"XOR r8,rm8"  ,"XOR r16,rm16","XOR AL,imm8" ,"XOR AX,imm16","SEG=SS"   ,"AAA"      ,
  "CMP rm8,r8"  ,"CMP rm16,r16"  ,"CMP r8,rm8"  ,"CMP r16,rm16","CMP AL,imm8" ,"CMP AX,imm16","SEG=CS"   ,"AAS"      ,
  "INC AX"      ,"INC CX"        ,"INC DX"      ,"INC BX"      ,"INC SP"   ,"INC BP"  ,"INC SI"   ,"INC DI"   ,
  "DEC AX"      ,"DEC CX"        ,"DEC DX"      ,"DEC BX"      ,"DEC SP"   ,"DEC BP"  ,"DEC SI"   ,"DEC DI"   ,
  "PUSH AX"     ,"PUSH CX"       ,"PUSH DX"     ,"PUSH BX"     ,"PUSH SP"  ,"PUSH BP" ,"PUSH SI"  ,"PUSH DI"  ,
  "POP AX"      ,"POP CX"        ,"POP DX"      ,"POP BX"      ,"POP SP"   ,"POP BP"  ,"POP SI"   ,"POP DI"   ,
  "PUSHA"       ,"POPA"          ,"BOUND ?"     ,"ARPL rm16,imm16","SEG=FS"   ,"SEG=GS"  ,"DB  66"    ,"DB  67"    ,
  "PUSH imm16"  ,"IMUL r16,imm16","PUSH imm8"   ,"IMUL r16,imm8","INSB"     ,"INSW"    ,"OUTSB"    ,"OUTSW"    ,
  "JO  rel8"     ,"JNO rel8"      ,"JB  rel8"     ,"JNB rel8"    ,"JZ  rel8"  ,"JNZ rel8","JBE rel8" ,"JNBE rel8",
  "JS  rel8"     ,"JNS rel8"      ,"JP  rel8"     ,"JNP rel8"    ,"JL  rel8"  ,"JNL rel8","JLE rel8" ,"JNLE rel8",
  "gr1 rm8,imm8","gr1 rm16,imm16","??"          ,"gr1 rm16,imm8","TEST r8,rm8"   ,"TEST r16,rm16","XCHG r8,rm8"   ,"XCHG r16,rm16",
  "MOV rm8,r8"  ,"MOV rm16,r16"  ,"MOV r8,rm8"  ,"MOV r16,rm16","MOV rm16,seg"    ,"LEA ??"  ,"MOV seg,rm16"    ,"POP ??"   ,
  "NOP"         ,"XCHG AX,CX"    ,"XCHG AX,DX"  ,"XCHG AX,BX"  ,"XCHG AX,SP"  ,"XCHG AX,BP" ,"XCHG AX,SI"  ,"XCHG AX,DI"  ,
  "CBW"         ,"CWD"           ,"CALL ?"      ,"WAIT"        ,"PUSHF ?"  ,"POPF ?"  ,"SAHF"     ,"LAHF"     ,
  "MOV AL,[imm16]","MOV AX,[imm16]","MOV [imm16],AL"  ,"MOV [imm16],AX","MOVSB"    ,"MOVSW"   ,"CMPSB"    ,"CMPSW"    ,
  "TEST AL,imm8","TEST AX,imm16" ,"STOSB"       ,"STOSW"       ,"LODSB"    ,"LODSW"   ,"SCASB"    ,"SCASW"    ,
  "MOV AL,imm8" ,"MOV CL,imm8"   ,"MOV DL,imm8" ,"MOV BL,imm8" ,"MOV AH,imm8" ,"MOV CH,imm8" ,"MOV DH,imm8" ,"MOV BH,imm8" ,
  "MOV AX,imm16","MOV CX,imm16"  ,"MOV DX,imm16","MOV BX,imm16","MOV SP,imm16","MOV BP,imm16","MOV SI,imm16","MOV DI,imm16", 
  "gr2 rm8,imm8","gr2 rm16,imm16","RET #"       ,"RET"         ,"LES ?"    ,"LDS ?"          ,"MOV rm8,imm8","MOV rm16,imm16",
  "ENTER ?"     ,"LEAVE"         ,"RET #"       ,"RET"         ,"INT 03"   ,"INT imm8"   ,"INTO"               ,"IRET"        ,
  "gr2 rm8,1"   ,"gr2 rm16,1"    ,"gr2 rm8,CL"  ,"gr2 rm16,CL" ,"AAM"      ,"AAD"     ,"??"                 ,"XLAT"        ,
  "ESC"         ,"ESC"           ,"ESC"         ,"ESC"         ,"ESC"      ,"ESC"     ,"ESC"                ,"ESC"         ,
  "LOOPNE rel8" ,"LOOPE rel8"    ,"LOOP rel8"   ,"JCXZ"        ,"IN  AL,imm8"  ,"IN  AX,imm8" ,"OUT imm8,AL"           ,"OUT imm8,AX"    ,
  "CALL rel16"  ,"JMP rel16"     ,"JMP ?"       ,"JMP rel8"    ,"IN  AL,DX" ,"IN  AX,DX"       ,"OUT DX,AL"   ,"OUT DX,AX"   ,
  "LOCK"        ,"??"            ,"REPNE"       ,"REP"    ,"HLT"      ,"CMC"            ,"gr3 rm8"     ,"gr3 rm16"    ,
  "CLC"         ,"STC"           ,"CLI"         ,"STI"         ,"CLD"      ,"STD"            ,"gr4"         ,"gr5"       
};

static char *DisasmReg8[8] =
{"AL","CL","DL","BL","AH","CH","DH","BH"};

static char *DisasmReg16[8] =
{"AX","CX","DX","BX","SP","BP","SI","DI"};

static char *DisasmReg32[8] =
{"EAX","ECX","EDX","EBX","ESP","EBP","ESI","EDI"};

static char *DisasmSegReg[8] =
{"ES","CS","SS","DS","FS","GS","??","??"};

static char *DisasmMod0[8] =
{"[BX+SI]","[BX+DI]","[BP+SI]","[BP+DI]","[SI]","[DI]","[imm16]","[BX]"};

static char *DisasmMod1[8] =
{"[BX+SI+imm8]","[BX+DI+imm8]","[BP+SI+imm8]","[BP+DI+imm8]","[SI+imm8]","[DI+imm8]","[BP+imm8]","[BX+imm8]"};

static char *DisasmMod2[8] =
{"[BX+SI+imm16]","[BX+DI+imm16]","[BX+SI+imm16]","[BX+DI+imm16]","[SI+imm16]","[DI+imm16]","[BP+imm16]","[BX+imm16]"};

static char *DisasmGrp1[8] =
{"ADD","OR","ADC","SBB","AND","SUB","XOR","CMP"};

static char *DisasmGrp2[8] =
{"ROL","ROR","RCL","RCR","SHL","SHR","??","SAR"};

static char *DisasmGrp3[8] =
{"TEST","??","NOT","NEG","MUL","IMUL","DIV","IDIV"};

static char *DisasmGrp4[8] =
{"INC rm8" ,"DEC rm8" ,"??","??","??","??","??","??"};

static char *DisasmGrp5[8] =
{"INC rm16","DEC rm16","CALL","??","JMP","??","PUSH","??"};

#endif
